Join Me!

version 1.41

Join Me! is an IRC server written from scratch for the Windows 9x - NT operating systems. It's written in Delphi using object pascal language. Based on the 1459 RFC, and experimenting the mIRC client and Bahamut server messages and replies makes it possible to use it with many IRC client programs like mIRC. It's very easy to use since it features a friendly windows GUI.

Join Me! is not intended for large internet networks due to miss of flood control and server to server communication. However, it is a convenient IRC server for local and small internet networks. It provides most of the IRC commands supported by specification of RFC 1459 and it's compatible with mIRC. Also supports a communication with external DLL plug-ins which act like BOTs on the IRC server. However, DLL BOTs are deprecated and may not be supported in the long distant future. Use third party BOTs like EggDrop.

Server user is able to monitor online users and available channels. He can change nicks, kill users and monitor server traffic.

Join Me is now Free Software.

Join Me! on the web : http://joinme.sourceforge.net


What's new?

Version 1.41 :

  • Small bug fixes

Version 1.4 :

  • Join Me is now Free Software!

Version 1.31 :

  • Fixed bugs about command line options (-start, -min, -nosplash)
  • Fixed system tray icon behavior
  • Moved to Delphi 6 again due to compatibility issues

Version 1.3 :

  • Added tray icon. No more task bar button appears when server is minimized
  • Corrected bug about moderated channels
  • Corrected bug about ISON command
  • Corrected bug about NICK command when user wasn't in any channel
  • Corrected bug about WHOIS command for operator users
  • Delphi 7 compiled
  • Nickname length is now 22 characters (old was 16)

Version 1.2 :

  • Asynchronous server name look up. No more delays while clients are trying to log in.
  • Bad captions corrected
  • Access Violation bug in Channel list form corrected
  • Access Violation bug in User list form corrected
  • Join Me server shuts down immediately when windows ends session (shut down, log off)

Version 1.1 :

  • No more shareware. It's now postcard ware!
  • Windows XP support
  • Graph monitoring forms created (total users online, total active channels and total messages in message send queue)
  • Some access violation bugs corrected
  • PONG command required registration. Bug corrected.
  • Remote host resolving optimized a little
  • User can execute only one instance of server
  • Moved from Delphi 5 to Delphi 6
  • Added a warning when shutting down server and there are users online
  • SVSNICK command supported
  • WALLOPS command supported
  • STATS command partially implemented


The GNU General Public License (GPL)

Version 2, June 1991

Copyright (C) 1989, 1991 Free Software Foundation, Inc.
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

Everyone is permitted to copy and distribute verbatim copies
of this license document, but changing it is not allowed.

Preamble

The licenses for most software are designed to take away your freedom to share and change it. By contrast, the GNU General Public License is intended to guarantee your freedom to share and change free software--to make sure the software is free for all its users. This General Public License applies to most of the Free Software Foundation's software and to any other program whose authors commit to using it. (Some other Free Software Foundation software is covered by the GNU Library General Public License instead.) You can apply it to your programs, too.

When we speak of free software, we are referring to freedom, not price. Our General Public Licenses are designed to make sure that you have the freedom to distribute copies of free software (and charge for this service if you wish), that you receive source code or can get it if you want it, that you can change the software or use pieces of it in new free programs; and that you know you can do these things.

To protect your rights, we need to make restrictions that forbid anyone to deny you these rights or to ask you to surrender the rights. These restrictions translate to certain responsibilities for you if you distribute copies of the software, or if you modify it.

For example, if you distribute copies of such a program, whether gratis or for a fee, you must give the recipients all the rights that you have. You must make sure that they, too, receive or can get the source code. And you must show them these terms so they know their rights.

We protect your rights with two steps: (1) copyright the software, and (2) offer you this license which gives you legal permission to copy, distribute and/or modify the software.

Also, for each author's protection and ours, we want to make certain that everyone understands that there is no warranty for this free software. If the software is modified by someone else and passed on, we want its recipients to know that what they have is not the original, so that any problems introduced by others will not reflect on the original authors' reputations.

Finally, any free program is threatened constantly by software patents. We wish to avoid the danger that redistributors of a free program will individually obtain patent licenses, in effect making the program proprietary. To prevent this, we have made it clear that any patent must be licensed for everyone's free use or not licensed at all.

The precise terms and conditions for copying, distribution and modification follow.

TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

0. This License applies to any program or other work which contains a notice placed by the copyright holder saying it may be distributed under the terms of this General Public License. The "Program", below, refers to any such program or work, and a "work based on the Program" means either the Program or any derivative work under copyright law: that is to say, a work containing the Program or a portion of it, either verbatim or with modifications and/or translated into another language. (Hereinafter, translation is included without limitation in the term "modification".) Each licensee is addressed as "you".

Activities other than copying, distribution and modification are not covered by this License; they are outside its scope. The act of running the Program is not restricted, and the output from the Program is covered only if its contents constitute a work based on the Program (independent of having been made by running the Program). Whether that is true depends on what the Program does.

1. You may copy and distribute verbatim copies of the Program's source code as you receive it, in any medium, provided that you conspicuously and appropriately publish on each copy an appropriate copyright notice and disclaimer of warranty; keep intact all the notices that refer to this License and to the absence of any warranty; and give any other recipients of the Program a copy of this License along with the Program.

You may charge a fee for the physical act of transferring a copy, and you may at your option offer warranty protection in exchange for a fee.

2. You may modify your copy or copies of the Program or any portion of it, thus forming a work based on the Program, and copy and distribute such modifications or work under the terms of Section 1 above, provided that you also meet all of these conditions:

a) You must cause the modified files to carry prominent notices stating that you changed the files and the date of any change.

b) You must cause any work that you distribute or publish, that in whole or in part contains or is derived from the Program or any part thereof, to be licensed as a whole at no charge to all third parties under the terms of this License.

c) If the modified program normally reads commands interactively when run, you must cause it, when started running for such interactive use in the most ordinary way, to print or display an announcement including an appropriate copyright notice and a notice that there is no warranty (or else, saying that you provide a warranty) and that users may redistribute the program under these conditions, and telling the user how to view a copy of this License. (Exception: if the Program itself is interactive but does not normally print such an announcement, your work based on the Program is not required to print an announcement.)

These requirements apply to the modified work as a whole. If identifiable sections of that work are not derived from the Program, and can be reasonably considered independent and separate works in themselves, then this License, and its terms, do not apply to those sections when you distribute them as separate works. But when you distribute the same sections as part of a whole which is a work based on the Program, the distribution of the whole must be on the terms of this License, whose permissions for other licensees extend to the entire whole, and thus to each and every part regardless of who wrote it.

Thus, it is not the intent of this section to claim rights or contest your rights to work written entirely by you; rather, the intent is to exercise the right to control the distribution of derivative or collective works based on the Program.

In addition, mere aggregation of another work not based on the Program with the Program (or with a work based on the Program) on a volume of a storage or distribution medium does not bring the other work under the scope of this License.

3. You may copy and distribute the Program (or a work based on it, under Section 2) in object code or executable form under the terms of Sections 1 and 2 above provided that you also do one of the following:

a) Accompany it with the complete corresponding machine-readable source code, which must be distributed under the terms of Sections 1 and 2 above on a medium customarily used for software interchange; or,

b) Accompany it with a written offer, valid for at least three years, to give any third party, for a charge no more than your cost of physically performing source distribution, a complete machine-readable copy of the corresponding source code, to be distributed under the terms of Sections 1 and 2 above on a medium customarily used for software interchange; or,

c) Accompany it with the information you received as to the offer to distribute corresponding source code. (This alternative is allowed only for noncommercial distribution and only if you received the program in object code or executable form with such an offer, in accord with Subsection b above.)

The source code for a work means the preferred form of the work for making modifications to it. For an executable work, complete source code means all the source code for all modules it contains, plus any associated interface definition files, plus the scripts used to control compilation and installation of the executable. However, as a special exception, the source code distributed need not include anything that is normally distributed (in either source or binary form) with the major components (compiler, kernel, and so on) of the operating system on which the executable runs, unless that component itself accompanies the executable.

If distribution of executable or object code is made by offering access to copy from a designated place, then offering equivalent access to copy the source code from the same place counts as distribution of the source code, even though third parties are not compelled to copy the source along with the object code.

4. You may not copy, modify, sublicense, or distribute the Program except as expressly provided under this License. Any attempt otherwise to copy, modify, sublicense or distribute the Program is void, and will automatically terminate your rights under this License. However, parties who have received copies, or rights, from you under this License will not have their licenses terminated so long as such parties remain in full compliance.

5. You are not required to accept this License, since you have not signed it. However, nothing else grants you permission to modify or distribute the Program or its derivative works. These actions are prohibited by law if you do not accept this License. Therefore, by modifying or distributing the Program (or any work based on the Program), you indicate your acceptance of this License to do so, and all its terms and conditions for copying, distributing or modifying the Program or works based on it.

6. Each time you redistribute the Program (or any work based on the Program), the recipient automatically receives a license from the original licensor to copy, distribute or modify the Program subject to these terms and conditions. You may not impose any further restrictions on the recipients' exercise of the rights granted herein. You are not responsible for enforcing compliance by third parties to this License.

7. If, as a consequence of a court judgment or allegation of patent infringement or for any other reason (not limited to patent issues), conditions are imposed on you (whether by court order, agreement or otherwise) that contradict the conditions of this License, they do not excuse you from the conditions of this License. If you cannot distribute so as to satisfy simultaneously your obligations under this License and any other pertinent obligations, then as a consequence you may not distribute the Program at all. For example, if a patent license would not permit royalty-free redistribution of the Program by all those who receive copies directly or indirectly through you, then the only way you could satisfy both it and this License would be to refrain entirely from distribution of the Program.

If any portion of this section is held invalid or unenforceable under any particular circumstance, the balance of the section is intended to apply and the section as a whole is intended to apply in other circumstances.

It is not the purpose of this section to induce you to infringe any patents or other property right claims or to contest validity of any such claims; this section has the sole purpose of protecting the integrity of the free software distribution system, which is implemented by public license practices. Many people have made generous contributions to the wide range of software distributed through that system in reliance on consistent application of that system; it is up to the author/donor to decide if he or she is willing to distribute software through any other system and a licensee cannot impose that choice.

This section is intended to make thoroughly clear what is believed to be a consequence of the rest of this License.

8. If the distribution and/or use of the Program is restricted in certain countries either by patents or by copyrighted interfaces, the original copyright holder who places the Program under this License may add an explicit geographical distribution limitation excluding those countries, so that distribution is permitted only in or among countries not thus excluded. In such case, this License incorporates the limitation as if written in the body of this License.

9. The Free Software Foundation may publish revised and/or new versions of the General Public License from time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new problems or concerns.

Each version is given a distinguishing version number. If the Program specifies a version number of this License which applies to it and "any later version", you have the option of following the terms and conditions either of that version or of any later version published by the Free Software Foundation. If the Program does not specify a version number of this License, you may choose any version ever published by the Free Software Foundation.

10. If you wish to incorporate parts of the Program into other free programs whose distribution conditions are different, write to the author to ask for permission. For software which is copyrighted by the Free Software Foundation, write to the Free Software Foundation; we sometimes make exceptions for this. Our decision will be guided by the two goals of preserving the free status of all derivatives of our free software and of promoting the sharing and reuse of software generally.

NO WARRANTY

11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

END OF TERMS AND CONDITIONS

How to Apply These Terms to Your New Programs

If you develop a new program, and you want it to be of the greatest possible use to the public, the best way to achieve this is to make it free software which everyone can redistribute and change under these terms.

To do so, attach the following notices to the program. It is safest to attach them to the start of each source file to most effectively convey the exclusion of warranty; and each file should have at least the "copyright" line and a pointer to where the full notice is found.

one line to give the program's name and a brief idea of what it does.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

Also add information on how to contact you by electronic and paper mail.

If the program is interactive, make it output a short notice like this when it starts in an interactive mode:

Gnomovision version 69, Copyright (C) year name of author Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'. This is free software, and you are welcome to redistribute it under certain conditions; type `show c' for details.

The hypothetical commands `show w' and `show c' should show the appropriate parts of the General Public License. Of course, the commands you use may be called something other than `show w' and `show c'; they could even be mouse-clicks or menu items--whatever suits your program.

You should also get your employer (if you work as a programmer) or your school, if any, to sign a "copyright disclaimer" for the program, if necessary. Here is a sample; alter the names:

Yoyodyne, Inc., hereby disclaims all copyright interest
in the program `Gnomovision' (which makes passes at compilers)
written by James Hacker.

signature of Ty Coon, 1 April 1989
Ty Coon, President of Vice

This General Public License does not permit incorporating your program into proprietary programs. If your program is a subroutine library, you may consider it more useful to permit linking proprietary applications with the library. If this is what you want to do, use the GNU Library General Public License instead of this License.


Commands supported

The commands supported are :

PASS, NICK, USER, OPER, QUIT, JOIN, PART, MODE, TOPIC, NAMES, LIST, INVITE, KICK, VERSION, LINKS*, TIME, TRACE*, ADMIN, INFO, PRIVMSG, NOTICE, WHO, WHOIS, WHOWAS, KILL, PING, PONG, AWAY, ERROR, RESTART, USERS, USERHOST, ISON, SVSNICK, STATS, WALLOPS

Commands for server to server communication are not supported. For more information about each command see RFC 1459 (IRC protocol specs).

* Only for current server


Users - Channels

Join Me! keeps a list with all online users and channels. The size of this list is limited according to server settings. If server is powered enough with memory, processing power and fast TCP link you may use large numbers of users.

A new user is created every time a new user connects with server. This user dies only when disconnecting from server. For each user server keeps all required information like nickname, username, realname, time logged in, user modes, etc.

Each user is able to join to a channel. If channel does not exist it's automatically created and the user becomes channel operator. All other users are no operators except if the operator offers this priviledge. For more information search for RFC 1459 on the internet.


Requirements

Requirements is a Pentium computer, 32 MB RAM, Windows 95, 98 ME or NT, 2000, XP. However, for clients to be able to connect there should be an internet connection or a local area network. That depends on how it will be used.


General settings

On the main menu choose Server -> Settings. The following form appears.

You can see the general settings here. You can configure the following :

TCP/IP Settings :

Port | The TCP/IP port that the server listens to.
Server Name | The name of the server (descriptive). It appears on the welcome message.
Network | A descriptive name of the IRC network i.e. GrNet

Generic Settings :

Allow Greek | Allows greek nicknames
Send MOTD | Sends the Message Of The Day text on welcome.
MOTD | The text file of the MOTD

User Restrictions :

Maximum Users | Maximum allowed users online
Maximum Channels / User | Maximum allowed active channels per user
Maximum Users / Host | Maximum allowed users connected from a unique host

Logs :

Debug | Logs all received / sent messages to "Debug.log"
Client Errors | Logs client socket errors to "Error.log"

Server WHOIS comment Comment that appears on the WHOIS command


Administrator settings

Here you can configure all information that are sent to a client as a reply to ADMIN command. These are:

Administrator settings :

Nick | Administrators nickname
Real Name | The administrator's real name
e-mail | Administrator's e-mail

Generic Settings :

e-mail a generic e-mail for the whole irc server


User operator settings

User operators settings

Here you can configure operator's usernames and passwords. For each user name there must be a corresponding password. You may define as many operators as you want. These information are used by the server to identify operator users during user registration or with the OPER command. When a user is operator he can use KILL command.


BOTs settings

Here you can configure BOT's directory. Each time the server initializes BOTs, they will be seek in this directory. If it is empty it is the directory where JoinMe.exe exists. For more information in configuring BOTs go to Available BOTs setting.


Available BOTs

Select from the main menu BOTS->Available BOTs.

Here you can configure each BOT individually. By checking / unchecking the check box you set a bot active/inactive. If a BOT is active it means that selecting "Start BOTs" from main menu starts this BOT. If a BOT is inactive it does not start.

By right clicking on a BOT's icon if you choose "config" you may configure a BOT (if the BOT implements BotConfig() function)


The BOT's API

Join Me! supports an open API for creating BOTs in DLLs. Each DLL represents a BOT for Join Me! BOT API.

The DLL should implement and export the following functions :

{BotIdentify function}
function BotIdentify (var
BotIdentifyData:TBotIdentifyData): boolean; stdcall;
{BotConnect function}
function BotConnect (SendMessageProc : TBotsndMsgProc; SocketID:DWord): boolean; stdcall;
{BotMessage function}
procedure BotMessage (const IRCBotMessage : TIRCBotMessage;cMsg : PChar); stdcall;
{BotDisconnect function}
procedure BotDisconnect; stdcall;
{BotFinalization function}
procedure BotFinalization;  stdcall;
{BotConfig function}
procedure BotConfig; stdcall;

BotIdentify() is called when server initializes BOTs. This happens before starting server. Server calls this function to retrieve some identification data about each BOT, its name for instance.

BotConnect() is called when starting BOTs. it's called after BOT has connected to server, so BOT is responsible for registering it self to server by sending the appropriate USER and NICK commands.

BotMessage() is called whenever a server message arrives to BOT. It's stored as null terminated string in cMsg parameter and processed in a structure IRCBotMessage.

BotDisconnect() is called before BOT gets disconnected.

BotFinalization() is called after BOT gets disconnected.

BotConfig() is called whenever user chooses "Config" in the Available BOTs form.

For more information check IRCSystemBotInterface.pas file which contains all information about data types used within JoinMe! and DLL communication.


Main window

The main window has the main menu where all available settings can be made. However, there is a bar with buttons bellow menu which provides faster access to most common menu items. In the window there are some useful information about server's activity.

To start the server all you have to do is to press the first button on the left, or choose Server -> Start / Stop server.


Command line options

Join Me! offers some command line options for fast use. These are :

-nosplash | No Startup Banner
-min | Start minimized
-start | Starts the irc server
-startbots | Starts the irc server and bot services just after the irc server is up and running


Users list

Join Me! provides to server user the ability to monitor online users. Server user can send a notice to some specific users, kill some users or view information about one.


Channels list

In this screen user can watch all the active channels and some information like topics, modes, number of users. Server user can also send a notice to a user, kill a user, view information about a user or even to change his nick!


Graphs

Join Me supports monitoring total users online, total active channels, and network traffic through graphs. These options are accessible through Users->Graphs selection.

Example (total active channels monitoring)


Author

 Hello there! I'm Elias Konstadinidis. I developed Join Me! I studied at TEI of Athens and I use computers a lot. Programming is one of my favourite activities but I also like going to gym, playing basketball, watching movies, listening to music and going to clubs and cafes.

If you want to contact with me to provide suggestions or bug report on Join Me! you may use coma256@hotmail.com. Besides you may visit my homepage at http://www.geocities.com/coma256.